<?php session_start();
date_default_timezone_set('America/Bogota');
//RESTRICCI�N DE ACCESO A TRABAJADOR (ACCESO INDIVIDUAL)
if (isset($_SESSION['tipousuario']))
		{if ($_SESSION['tipousuario']=='1')
		header ('location:menu_personal.php');
		}
if  (trim($_SESSION['nombre_validar'])=='') header ('location:index.php');
include ("fphp.php");
$enlace=cargar_conexion();
$consulta=mysql_query("select * from periodo where id='".$_SESSION['id_validar']."' order by nomina,periodo desc limit 1");
if (mysql_num_rows($consulta)!=0){
	$row=mysql_fetch_array($consulta);
	$_SESSION['per_validar']=mostrar_fecha($row['desde']).' al '.mostrar_fecha($row['hasta'])." (Nom:".$row['nomina'].")";
} else $_SESSION['per_validar']='';
menu();

$accion=$_REQUEST["accion"];
$codigo=$_REQUEST["codigo"];
$cedula=$_REQUEST["cedula"];
$constante=$_REQUEST["constante"];
$ordena=$_REQUEST["ordena"];
$nomina=$_REQUEST["nomina"];
$monto=$_REQUEST["monto"];

echo "<font face='verdana' size=2>";

if(isset($_POST['generarBanco'])){
    //----------------VARIABLES PARA LA CABECERA------------------------//

    


    //--Se define el periodo que se esta trabajando
    $periodo = $_POST['periodo'];
    $periodo = explode(' ',$periodo);
    $desde = date('Y-m-d',strtotime($periodo[0]));
    $hasta = date('Y-m-d',strtotime($periodo[1]));
    //------------------------------//
    //-----Se declara variables para uso despues
    $n = null;
    $n_alterno = null;
    //-------Año actual
    $year = date('y');
    $type = null;
    //---Si la nomina es normal, de contingencia o de fideicomiso, el tipo es 1
    if($_POST['nomina'] == 'nomina_contingencia' || $_POST['nomina'] == 'nomina_normal' ){
        $type = 1;
    }else if( $_POST['nomina'] == 'nomina_fideicomiso'){
        $type = 5;
    }
    //--- Se declara la fecha y a partir de alli se busca el ultimo dia vigente
    $semanainicio = date("W",strtotime($desde));
    $semanafin = date("W",strtotime($hasta));

    $numberWeek = null;
    for ($i = $semanainicio; $i <=  $semanafin; $i++)
    {
        $numberWeek = $i;
    }
    //---- Fecha actual acomodada para txt
    $dateNow = date('Y-m-d');
    $dateNow = explode("-",$dateNow);
    $dateNow = $dateNow[0]."".$dateNow[1]."".$dateNow[2];

    // A partir del tipo de nomina, se declara un autoincrementable
    if($_POST['tipo_nomina'] == '100'){
        $n = 2;
        $n_alterno = 21;

    }else if($_POST['tipo_nomina']=='200'){
        $n = 1;
        $n_alterno = 11;
    }
    //Se cuadran las fecha y se buscan los dias habiles para tomar el ultimo que servira como pago
    $desdeI = strtotime($desde);
    $hastaF = strtotime($hasta);
    // echo $desdeI."<br>";
    // echo $hastaF."<br>";
    $diainc = 24*60*60;
    $diashabiles = [];
    for ($midia = $desdeI; $midia <= $hastaF; $midia += $diainc) {
            if (!in_array(date('N', $midia), array(6,7))) {  
                array_push($diashabiles, date('Y-m-d', $midia));    
            }
    }

    $fecha_tramite = [];
    // var_dump($diashabiles);
    $tipo_nomina = null;
    // A partir del tipo de contingencia, se toma la fecha y se le agrega los dias que serviran para el pago a efectuar
    if ($_POST['nomina'] == 'nomina_contingencia') {
        $tipo_nomina = "CONTING0";
        $fecha_tramite = end($diashabiles);
        $fecha_tramite = explode("-",$fecha_tramite);
        $fecha_tramite = $fecha_tramite[0]."".$fecha_tramite[1]."".$fecha_tramite[2];
    }elseif ($_POST['nomina'] == 'nomina_normal' || $_POST['nomina'] == 'nomina_fideicomiso') {
        $tipo_nomina = "99999990";
        $fecha_tramite = end($diashabiles);
        $fecha_tramite = date('Y-m-d',strtotime($fecha_tramite."+ 3 days"));
        $fecha_tramite = explode("-",$fecha_tramite);
        $fecha_tramite = $fecha_tramite[0]."".$fecha_tramite[1]."".$fecha_tramite[2];
    }


    // echo $fecha_tramite;
    // Recolecto el listado de cedulas correspondientes al periodo vigente
    $query = "SELECT DISTINCT cedula as cedula FROM `historico`";
    $resultado = mysql_query($query);
    $cedulas = [];
    while($datesCodes = mysql_fetch_array($resultado)){
        $cedulas[] = $datesCodes['cedula'];
    }
    $sum = null;
    $res = null;

    // Se realiza la sumatoria total del monto de los empleados en general
    foreach ($cedulas as $c) {
        $query2 = "SELECT SUM(monto) as monto FROM `historico` WHERE cedula = '$c' AND tipo = 'A'";
        $resultado = mysql_query($query2);
        while ($sumatoria = mysql_fetch_array($resultado)) {
            $sum += $sumatoria['monto'];
        }
    }
    foreach ($cedulas as $c) {
        $query2 = "SELECT SUM(monto) as monto FROM `historico` WHERE cedula = '$c' AND tipo = 'D'";
        $resultado = mysql_query($query2);
        while ($sumatoria = mysql_fetch_array($resultado)) {
            $res += $sumatoria['monto'];
        }
    }
    $monto_a_pagar = $sum-$res;
    $monto_a_pagar = intval($monto_a_pagar);

    //-------------CREACIÓN DE EL ARCHIVO

    //-------------------------------------------------//
    $nombre_archivo = "Nominas/nomina".date('dmy').".txt";
    $file = fopen($nombre_archivo,"w+");
    //----------------------------HEADER--------------//
    fwrite($file,"HDR");
    fwrite($file,"UNIOVECA       ED  95BPAYMULP");
    fwrite($file,"\n");
    fwrite($file,"01");
    fwrite($file,$tipo_nomina);
    fwrite($file,$n);
    fwrite($file,$year);
    fwrite($file,$type);
    fwrite($file,"2");
    fwrite($file,$numberWeek);
    fwrite($file,"9");
    fwrite($file,"  ");
    fwrite($file,$dateNow);
    fwrite($file,"SALJ000148643");
    fwrite($file,"       FORD MOTOR VENEZUELA S.A.");
    fwrite($file,"\n");
    fwrite($file,"02");
    fwrite($file,$fecha_tramite);
    fwrite($file,"0".$n);
    fwrite($file,$year);
    fwrite($file,$type);
    fwrite($file,"2");
    fwrite($file,$numberWeek);
    fwrite($file,"               ");
    fwrite($file,"0000000000".$monto_a_pagar);
    fwrite($file,"VES");
    fwrite($file,"01340968419683001284               UNIOVECA   ");
    fwrite($file,"\n");
    //--------------------------------------------------//
    //-------------------------BODY----------------------//
    foreach ($cedulas as $c) {
        $sum_por_empleado;
        $res_por_empleado;
        $monto_por_empleado;
        fwrite($file,"03");
        fwrite($file,"9  ");
        $query = "SELECT SUM(monto) as monto FROM `historico` WHERE cedula = '$c' AND tipo = 'A'";
        $resultado = mysql_query($query);
        while ($sumatoria = mysql_fetch_array($resultado)) {
            $sum_por_empleado += $sumatoria['monto'];
        }
        $query2 = "SELECT SUM(monto) as monto FROM `historico` WHERE cedula = '$c' AND tipo = 'D'";
        $resultado = mysql_query($query2);
        while ($sumatoria = mysql_fetch_array($resultado)) {
            $res_por_empleado += $sumatoria['monto'];
        }
        $monto_por_empleado = $sum_por_empleado - $res_por_empleado;
        $monto_por_empleado = intval($monto_por_empleado);
        if(strlen($monto_por_empleado)==6){
            fwrite($file,"000000000");
        }else if(strlen($monto_por_empleado)==7){
            fwrite($file,"00000000");
        }else if(strlen($monto_por_empleado)==8){
            fwrite($file,"0000000");
        }else if(strlen($monto_por_empleado)==9){
            fwrite($file,"000000");
        }else if(strlen($monto_por_empleado)==10){
            fwrite($file,"00000");
        }
        fwrite($file,$monto_por_empleado);
        fwrite($file,"VES01");
        fwrite($file,$n_alterno);
        $query3 = "SELECT * FROM `personal` WHERE codigo = '$c'";
        $resultado = mysql_query($query3);
        $datos_empleado = mysql_fetch_array($resultado);
        fwrite($file,$datos_empleado['global_id']);
        //fwrite($file,"          ");
        fwrite($file,"  42   ");
        fwrite($file,$datos_empleado['cuenta']);
        //fwrite($file,"              UNIOVECA         ");
        /*if(fwrite($file,"              UNIOVECA         ") == false){
	
            echo ("<script> console.log('No copió'); </script>");
            
        }else{
            
            echo ("<script> console.log('Sí copió'); </script>");
        }*/
        fwrite($file," ");
        fwrite($file,$datos_empleado['nacionalidad']);
        fwrite($file,"00".$datos_empleado['codigo']);
        //fwrite($file,"                                                                                                                 ");
        //fwrite($file,$datos_empleado['apellidos']." ".$datos_empleado['apellidos1']." ".$datos_empleado['nombres']." ".$datos_empleado['nombres1']);
        fwrite($file,"\n");
        //

    }

    //---------------------------------------------------//
    //-------------FOOTER--------------------------------//
    fwrite($file,"06");
    fwrite($file,"000000000000001000000000000");
    fwrite($file,count($cedulas));
    fwrite($file,"0000000000".$monto_a_pagar);
    //---------------------------------------------------//
    fclose($file);
    echo "<style>
    .regristrado{
        color: green;
        margin-left: 7%;
        font-weight: bold;
    }
    </style>";
    echo "<p class='regristrado'>Archivo guardado correctamente<p>";

    echo "<script>
        window.location.href = 'generar_txt.php?fileBank=$nombre_archivo';
        </script>";
  
}


$query = "SELECT * FROM nomina";
$consulta=mysql_query($query);
$resultado=mysql_num_rows($consulta);


//--Desde - Hasta Consulta
$consultaDesdeHastaDiaria = mysql_query("SELECT `desde`,`hasta` from periodo where nomina='".$_SESSION['id_validar']."'");

// var_dump($fila);
//guardado de datos
////SCRIPTS///
?>

<head>
<script src="https://code.jquery.com/jquery-3.5.1.min.js"></script>
<script src="autocompletar/js/bootstrap3-typeahead.min.js"></script>

<link rel="stylesheet" href="css/timepicker.min.css">
<script src="js/timepicker.min.js"></script>

<link rel="stylesheet" href="//code.jquery.com/ui/1.12.1/themes/base/jquery-ui.css">
<script src="https://code.jquery.com/ui/1.12.1/jquery-ui.js"></script>

<script src='js/bootstrap.min.js'></script>

<!-- <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css"
	integrity="sha384-BVYiiSIFeK1dGmJRAkycuHAHRg32OmUcww7on3RYdg4Va+PmSTsz/K68vbdEjh4u" crossorigin="anonymous">

<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"
		integrity="sha384-Tc5IQib027qvyjSMfHjOMaLkfuWVxZxUPnCJA7l2mCWNIpG9mGCD8wGNIcPD7Txa"
		crossorigin="anonymous"></script> -->
<!-- 
<script src="//cdn.datatables.net/1.10.25/js/jquery.dataTables.min.js"></script>
<link rel="stylesheet" href="//cdn.datatables.net/1.10.25/css/jquery.dataTables.min.css"> -->



</head>
<style>
	.dropdown-menu>.active>a, .dropdown-menu>.active>a:focus, .dropdown-menu>.active>a:hover {
		color: #fff;
		text-decoration: none;
		background-color: #337ab7;
		outline: 0;
	}
	#tabla_novedades .horas_extras, .ausencia_medica, .validado_por_sso, .justificacion_ausencia, .remunerado_ausencia, .tiempo_viaje_ausencia, .ausencia, .ausencia_programada, .tipo_permiso_ausencia, .retardo, .salida_anticipada, .horassalida_anticipada, .datos_trabajador, .hora_salida_ausencia, .hora_llegada_ausencia  {
  	display: none;
	}
	#ocultar {
  	display: none;
	}

	.form-control-time {
	width: 80px;
    height: 34px;
    padding: 6px 12px;
    font-size: 12px;
    line-height: 1.42857143;
    color: #555;
    background-color: #fff;
    background-image: none;
    border: 1px solid #ccc;
    border-radius: 4px;
    -webkit-box-shadow: inset 0 1px 1px rgba(0, 0, 0, .075);
    box-shadow: inset 0 1px 1px rgba(0, 0, 0, .075);
    -webkit-transition: border-color ease-in-out .15s, box-shadow ease-in-out .15s;
    transition: border-color ease-in-out .15s, box-shadow ease-in-out .15s;
	}
	.boton{
    /* width: 100%; */
    color: #FFFFFF;
    /* font-size: 0.8725em; */
    padding: 7px;
    margin-bottom: 5px;
    margin-top: 10px;
    outline: none;
    /* margin: 5px 0; */
    font-family: 'Open Sans', sans-serif;
    font-size: 16px;
    font-weight: bold;
    text-transform: uppercase;
    background: #36C1E2;
    border: 0px solid #DFDFDF;
	}

    .glyphicon-modal-window:before{content:"\e237"}
    .modal-open{overflow:hidden}
    .modal{position:fixed;top:0;right:0;bottom:0;left:0;z-index:1050;display:none;overflow:hidden;-webkit-overflow-scrolling:touch;outline:0}
    .modal.fade .modal-dialog{-webkit-transform:translate(0,-25%);-ms-transform:translate(0,-25%);-o-transform:translate(0,-25%);transform:translate(0,-25%);-webkit-transition:-webkit-transform .3s ease-out;-o-transition:-o-transform .3s ease-out;transition:-webkit-transform .3s ease-out;transition:transform .3s ease-out;transition:transform .3s ease-out,-webkit-transform .3s ease-out,-o-transform .3s ease-out}
    .modal.in .modal-dialog{-webkit-transform:translate(0,0);-ms-transform:translate(0,0);-o-transform:translate(0,0);transform:translate(0,0)}
    .modal-open .modal{overflow-x:hidden;overflow-y:auto}
    .modal-dialog{position:relative;width:auto;margin:10px}
    .modal-content{position:relative;background-color:#fff;background-clip:padding-box;border:1px solid #999;border:1px solid rgba(0,0,0,.2);border-radius:6px;-webkit-box-shadow:0 3px 9px rgba(0,0,0,.5);box-shadow:0 3px 9px rgba(0,0,0,.5);outline:0}
    .modal-backdrop{position:fixed;top:0;right:0;bottom:0;left:0;z-index:1040;background-color:#000}
    .modal-backdrop.fade{filter:alpha(opacity=0);opacity:0}
    .modal-backdrop.in{filter:alpha(opacity=50);opacity:.5}
    .modal-header{padding:15px;border-bottom:1px solid #e5e5e5}
    .modal-header .close{margin-top:-2px}
    .modal-title{margin:0;line-height:1.42857143}
    .modal-body{position:relative;padding:15px}
    .modal-footer{padding:15px;text-align:right;border-top:1px solid #e5e5e5}
    .modal-footer .btn+.btn{margin-bottom:0;margin-left:5px}
    .modal-footer .btn-group .btn+.btn{margin-left:-1px}
    .modal-footer .btn-block+.btn-block{margin-left:0}
    .modal-scrollbar-measure{position:absolute;top:-9999px;width:50px;height:50px;overflow:scroll}@media (min-width:768px){.modal-dialog{width:600px;margin:30px auto}
    .modal-content{-webkit-box-shadow:0 5px 15px rgba(0,0,0,.5);box-shadow:0 5px 15px rgba(0,0,0,.5)}
    .modal-sm{width:300px}}@media (min-width:992px){.modal-lg{width:900px}}
    .tooltip{position:absolute;z-index:1070;display:block;font-family:"Helvetica Neue",Helvetica,Arial,sans-serif;font-style:normal;font-weight:400;line-height:1.42857143;line-break:auto;text-align:left;text-align:start;text-decoration:none;text-shadow:none;text-transform:none;letter-spacing:normal;word-break:normal;word-spacing:normal;word-wrap:normal;white-space:normal;font-size:12px;filter:alpha(opacity=0);opacity:0}
    .tooltip.in{filter:alpha(opacity=90);opacity:.9}
</style>

<style>

/*the container must be positioned relative:*/
.autocomplete {
  position: relative;
  display: inline-block;
  text-transform: capitalize;
}
.autocompletar{
	text-transform: capitalize;
}
.regristrado{
	color: green;
	margin-left: 7%;
	font-weight: bold;
}

.noregristrado{
	color: red;
	margin-left: 7%;
	font-weight: bold;
}

.autocomplete-items {
  position: absolute;
  border: 1px solid #d4d4d4;
  border-bottom: none;
  border-top: none;
  z-index: 99;
  /*position the autocomplete items to be the same width as the container:*/
  top: 100%;
  left: 0;
  right: 0;
}

.autocomplete-items div {
  padding: 5px;
  cursor: pointer;
  background-color: #fff;
  border-bottom: 1px solid #d4d4d4;
}

/*when hovering an item:*/
.autocomplete-items div:hover {
  background-color: #e9e9e9;
}

/*when navigating through the items using the arrow keys:*/
.autocomplete-active {
  background-color: DodgerBlue !important;
  color: #ffffff;
}
</style>
<body>
<?php

//////////////////////////////////////////////////////////////////////////////// INICIO MENU DE OPCIONES
			echo "<main class='container'>";
			echo "<section class='row text-center'>";	
			echo "<h2 class='text-dark text-left'><b>Generar bancos</b></h2>";
			// echo $_SERVER['PHP_SELF']."&codigo=".$_SESSION['codigo_cedula'];
	
			echo "<div class='col-sm-12 justify-content-center m-auto'>";
            echo "<form autocomplete='off' name = 'entrada' action = '".$_SERVER['PHP_SELF']."' method = 'POST'  enctype='multipart/form-data'>";
			echo "<input type = 'hidden' name = 'inicio' value = '1'>";
            echo "<div class='form-group form-inline'>";
            echo "<label name='label-novedad'>Tipo de Archivo:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</label>
                    <select style='width:210px;' name='nomina' id='nomina' class='form-control'>
                        <option value='' selected> Seleccione";
                        echo "<option value='nomina_normal'>Nómina a Pagar</option>";
                        echo "<option value='nomina_contingencia'>Contingencia</option>";
                        echo "<option value='nomina_fideicomiso'>Fideicomiso</option>";
            echo "</select>";
            echo "</div>&nbsp;&nbsp;";
            echo "<div class='form-group form-inline'>";
            echo "<label name='label-novedad'>Tipo de Nómina:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</label>
                    <select style='width:210px;' name='tipo_nomina' id='tipo_nomina' class='form-control''>
                        <option value='' selected> Seleccione";
                        while($fila=mysql_fetch_array($consulta)){
                            echo "<option value='".$fila['codigo']."'>".ucwords(strtolower($fila['detalle']))."";
                        }  
            echo "</select>";
            echo "</div>&nbsp;&nbsp;";
            echo "<div class='form-group form-inline'>";
            echo "<label name='label-novedad'>Período:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</label>
                    <select style='width:210px;' name='periodo' id='periodo' class='form-control'>
                        <option value='' selected> Seleccione";       
            echo "</select>";
               
                echo "
            </div>&nbsp;&nbsp;";
            echo '<input name="generarBanco" type="submit" class="boton" value="Generar reporte"></input>';
            echo "</form>";    
			echo "</section>";
			echo "</main>";

	?>

    <script>
        $('#tipo_nomina').change(function() {
            var tipo_nomina = $('#tipo_nomina').val();
            var dates = new FormData();
            dates.append('tipo_nomina', tipo_nomina);
            fetch('autocompletar/consultahorario.php',{
                method: 'POST',
                body: dates
            })
            .then(res => res.json())
            .then(data => {
                if(data == 'Error'){
                    console.log('error');
                }else{
                }
                if(tipo_nomina==100){
                    $('#periodo').empty();
                    $('#periodo').append($("<option>",{
                        value: '',
                        text: 'Seleccione'
                    }));
                    for(i=0;i<data.length;i++){
                        $('#periodo').append($("<option>",{
                            value:  data[i]['desde'] +' '+ data[i]['hasta'],
                            text: data[i]['desde'] +'  '+ data[i]['hasta']
                        }));
                    }
                    
                    
                    console.log(data[1]['desde']);
                }else if(tipo_nomina==200){
                     $('#periodo').empty();
                    $('#periodo').append($("<option>",{
                        value: '',
                        text: 'Seleccione'
                    }));
                    if(data!==null){
                        for(i=0;i<data.length;i++){
                            $('#periodo').append($("<option>",{
                                value:  data[i]['desde'] +' '+ data[i]['hasta'],
                                text: data[i]['desde'] +'  '+ data[i]['hasta']
                            }));
                        }
                        console.log(data);
                    }
                }
            });
        });
    </script>
</body>
</html>
